<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>ALIAS_DB Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248767"></a>ALIAS_DB Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Daniel-Constantin</span> <span class="surname">Mierla</span></h3><code class="email">&lt;<a class="email" href="mailto:team@voice-system.ro">team@voice-system.ro</a>&gt;</code></div><div class="author"><h3 class="author"><span class="firstname">Elena-Ramona</span> <span class="surname">Modroiu</span></h3><code class="email">&lt;<a class="email" href="mailto:team@voice-system.ro">team@voice-system.ro</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Daniel-Constantin</span> <span class="surname">Mierla</span></h3><code class="email">&lt;<a class="email" href="mailto:team@voice-system.ro">team@voice-system.ro</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2005-2009 Voice Sistem SRL</p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id277941">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id280646">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id282289">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id284073">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248001">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249264">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249270">1.3.1. <code class="varname">db_url</code> (str)</a></span></dt><dt><span class="section"><a href="#id249627">1.3.2. <code class="varname">user_column</code> (str)</a></span></dt><dt><span class="section"><a href="#id249609">1.3.3. <code class="varname">domain_column</code> (str)</a></span></dt><dt><span class="section"><a href="#id248918">1.3.4. <code class="varname">alias_user_column</code> (str)</a></span></dt><dt><span class="section"><a href="#id248957">1.3.5. <code class="varname">alias_domain_column</code> (str)</a></span></dt><dt><span class="section"><a href="#id293431">1.3.6. <code class="varname">domain_prefix</code> (str)</a></span></dt><dt><span class="section"><a href="#id293468">1.3.7. <code class="varname">append_branches</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293506">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293511">1.4.1. 
		<code class="function">alias_db_lookup( table_name [,flags] )</code>
		</a></span></dt><dt><span class="section"><a href="#id293600">1.4.2. 
		<code class="function">alias_db_find( table_name , input, output [,flags] )</code>
		</a></span></dt></dl></dd></dl></dd><dt><span class="chapter"><a href="#id294339">2. Frequently Asked Questions</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249303">Set <code class="varname">db_url</code> parameter</a></dt><dt>1.2. <a href="#id249593">Set <code class="varname">user_column</code> parameter</a></dt><dt>1.3. <a href="#id248902">Set <code class="varname">domain_column</code> parameter</a></dt><dt>1.4. <a href="#id248940">Set <code class="varname">alias_user_column</code> parameter</a></dt><dt>1.5. <a href="#id293415">Set <code class="varname">alias_domain_column</code> parameter</a></dt><dt>1.6. <a href="#id293452">Set <code class="varname">domain_prefix</code> parameter</a></dt><dt>1.7. <a href="#id293489">Set <code class="varname">append_branches</code> parameter</a></dt><dt>1.8. <a href="#id293583"><code class="function">alias_db_lookup()</code> usage</a></dt><dt>1.9. <a href="#id293701"><code class="function">alias_db_find()</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id277941"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id280646"></a>1.1. Overview</h2></div></div></div><p>
	ALIAS_DB module can be used as an alternative for user aliases
	via usrloc. The main feature is that it does not store all adjacent
	data as for user location and always uses database for search (no
	memory caching).
	</p><p>
	Having no memory caching, search speed might decrease but 
	provisioning is easier. With very fast databases like MySQL, speed
	penalty can be lowered. Also, search can be performed on different
	tables in the same script.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id282289"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284073"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>database module</em></span> (mysql, dbtext, ...).
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248001"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249264"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249270"></a>1.3.1. <code class="varname">db_url</code> (str)</h3></div></div></div><p>
		Database URL.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">mysql://opensipsro:opensipsro@localhost/opensips</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249303"></a><p class="title"><b>Example 1.1. Set <code class="varname">db_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("alias_db", "db_url", "dbdriver://username:password@dbhost/dbname")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249627"></a>1.3.2. <code class="varname">user_column</code> (str)</h3></div></div></div><p>
		Name of the column storing username.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">username</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249593"></a><p class="title"><b>Example 1.2. Set <code class="varname">user_column</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("alias_db", "user_column", "susername")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249609"></a>1.3.3. <code class="varname">domain_column</code> (str)</h3></div></div></div><p>
		Name of the column storing user's domain.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">domain</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248902"></a><p class="title"><b>Example 1.3. Set <code class="varname">domain_column</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("alias_db", "domain_column", "sdomain")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248918"></a>1.3.4. <code class="varname">alias_user_column</code> (str)</h3></div></div></div><p>
		Name of the column storing alias username.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">alias_username</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248940"></a><p class="title"><b>Example 1.4. Set <code class="varname">alias_user_column</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("alias_db", "alias_user_column", "auser")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248957"></a>1.3.5. <code class="varname">alias_domain_column</code> (str)</h3></div></div></div><p>
		Name of the column storing alias domain.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">alias_domain</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293415"></a><p class="title"><b>Example 1.5. Set <code class="varname">alias_domain_column</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("alias_db", "alias_domain_column", "adomain")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293431"></a>1.3.6. <code class="varname">domain_prefix</code> (str)</h3></div></div></div><p>
		Specifies the prefix to be stripped from the domain in R-URI before
		doing the search.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">NULL</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293452"></a><p class="title"><b>Example 1.6. Set <code class="varname">domain_prefix</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("alias_db", "domain_prefix", "sip.")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293468"></a>1.3.7. <code class="varname">append_branches</code> (int)</h3></div></div></div><p>
			If the alias resolves to many SIP IDs, the first is replacing
			the R-URI, the rest are added as branches.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">0</span>&#8221; (0 - don't add branches;
			1 - add branches).
		</em></span>
		</p><div class="example"><a name="id293489"></a><p class="title"><b>Example 1.7. Set <code class="varname">append_branches</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("alias_db", "append_branches", 1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293506"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293511"></a>1.4.1. 
		<code class="function">alias_db_lookup( table_name [,flags] )</code>
		</h3></div></div></div><p>
		The function takes the R-URI and search to see whether it is an alias
		or not. If it is an alias for a local user, the R-URI is replaced with
		user's SIP uri.
		</p><p>
		The function returns TRUE if R-URI is alias and it was replaced by
		user's SIP uri.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>table_name</em></span> - the name of the table
				where to search for alias. It can include pseudo-variables.
			</p></li><li><p><span class="emphasis"><em>flags</em></span> (optional) - set of flags 
			(char based flags) to control the alias lookup process:
			</p><div class="itemizedlist"><ul type="circle"><li><p><span class="emphasis"><em>d</em></span> - do not use domain URI part in
				the alias lookup query (use only a username-based lookup). By
				default, both username and domain are used.
				</p></li><li><p><span class="emphasis"><em>r</em></span> - do revers alias lookup - lookup
				for the alias mapped to the current URI (URI 2 alias 
				translation); normally, the function looks up for the URI 
				mapped to the alias (alias 2 URI translation).
				</p></li></ul></div></li></ul></div><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE.
		</p><div class="example"><a name="id293583"></a><p class="title"><b>Example 1.8. <code class="function">alias_db_lookup()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
alias_db_lookup("dbaliases" , "rd");
alias_db_lookup("dba_$(rU{s.substr,0,1})");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293600"></a>1.4.2. 
		<code class="function">alias_db_find( table_name , input, output [,flags] )</code>
		</h3></div></div></div><p>
		The function is very similar to <code class="function">alias_db_lookup()</code>,
		but instead of using fixed input (RURI) and output (RURI) is able to
		get the input SIP URI from a pseudo-variable and place the result back
		also in a pseudo-variable.
		</p><p>
		The function is useful as the alias lookup does not affect the request
		itself (no RURI changes), can be used in a reply context (as it does 
		not work with RURI only) and can be used for others URI than the RURI
		(To URI, From URI, custom URI).
		</p><p>
		The function returns TRUE if any alias mapping was found and returned.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>table_name</em></span> - the name of the table
				where to search for alias. It can include pseudo-variables.
			</p></li><li><p><span class="emphasis"><em>input</em></span> - any PV (pseudo-variable) 
			carrying the SIP URI that needs to be looked up.
			</p></li><li><p><span class="emphasis"><em>ouput</em></span> - PV (AVP or script VAR) 
			where to place the SIP URI resulting from the alias lookup.
			</p></li><li><p><span class="emphasis"><em>flags</em></span> (optional) - set of flags 
			(char based flags) to control the alias lookup process:
			</p><div class="itemizedlist"><ul type="circle"><li><p><span class="emphasis"><em>d</em></span> - do not use domain URI part in
				the alias lookup query (use only a username-based lookup). By
				default, both username and domain are used.
				</p></li><li><p><span class="emphasis"><em>r</em></span> - do revers alias lookup - lookup
				for the alias mapped to the current URI (URI 2 alias 
				translation); normally, the function looks up for the URI 
				mapped to the alias (alias 2 URI translation).
				</p></li></ul></div></li></ul></div><p>
		This function can be used from REQUEST_ROUTE, BRANCH_ROUTE,
			LOCAL_ROUTE, FAILURE_ROUTE and ONREPLY_ROUTE.
		</p><div class="example"><a name="id293701"></a><p class="title"><b>Example 1.9. <code class="function">alias_db_find()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# do revers alias lookup and find the alias for the FROM URI
alias_db_find("dbaliases" , "$fu", "$avp(from_alias)", "r");
...
</pre></div></div><br class="example-break"></div></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id294339"></a>Chapter 2. Frequently Asked Questions</h2></div></div></div><div class="qandaset"><table border="0" summary="Q and A Set"><col align="left" width="1%"><tbody><tr class="question"><td align="left" valign="top"><a name="id294343"></a><a name="id294026"></a><p><b>2.1.</b></p></td><td align="left" valign="top"><p>What happened with old use_domain parameter</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			The global parameter (affecting the entire module) was replaced 
			with a per lookup parameter (affecting only current lookup).
			See the "d" (do not used domain part) flag in the db_alias_lookup()
			and db_alias_find() functions.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294352"></a><a name="id294354"></a><p><b>2.2.</b></p></td><td align="left" valign="top"><p>How can I report a bug?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Please follow the guidelines provided at:
			<a class="ulink" href="https://github.com/OpenSIPS/opensips/issues" target="_top">https://github.com/OpenSIPS/opensips/issues</a>.
		</p></td></tr></tbody></table></div></div></div></body></html>
